import { vec3, vec4 } from 'gl-matrix';
import { Context } from '../context';
import { Material } from '../scene';
import { Texture2D } from '../texture2d';
export declare enum GLTFShaderFlags {
    HAS_NORMALS = 1,
    HAS_TANGENTS = 2,
    HAS_UV = 4,
    HAS_COLORS = 8,
    USE_IBL = 16,
    HAS_BASECOLORMAP = 32,
    HAS_NORMALMAP = 64,
    HAS_EMISSIVEMAP = 128,
    HAS_METALROUGHNESSMAP = 256,
    HAS_OCCLUSIONMAP = 512,
    USE_TEX_LOD = 1024
}
export declare enum GLTFAlphaMode {
    OPAQUE = 0,
    MASK = 1,
    BLEND = 2
}
export declare class GLTFPbrMaterial extends Material {
    protected _baseColorTexture: Texture2D | undefined;
    protected _metallicRoughnessTexture: Texture2D | undefined;
    protected _normalTexture: Texture2D | undefined;
    protected _occlusionTexture: Texture2D | undefined;
    protected _emissiveTexture: Texture2D | undefined;
    protected _baseColorFactor: vec4;
    protected _metallicFactor: number;
    protected _emissiveFactor: vec3;
    protected _roughnessFactor: number;
    protected _isDoubleSided: boolean;
    protected _normalScale: number;
    protected _alphaMode: GLTFAlphaMode;
    protected _alphaCutoff: number;
    baseColorTexCoord: number;
    metallicRoughnessTexCoord: number;
    normalTexCoord: number;
    occlusionTexCoord: number;
    emissiveTexCoord: number;
    constructor(context: Context, name: string);
    baseColorTexture: Texture2D | undefined;
    metallicRoughnessTexture: Texture2D | undefined;
    normalTexture: Texture2D | undefined;
    occlusionTexture: Texture2D | undefined;
    emissiveTexture: Texture2D | undefined;
    emissiveFactor: vec3;
    baseColorFactor: vec4;
    metallicFactor: number;
    roughnessFactor: number;
    normalScale: number;
    isDoubleSided: boolean;
    alphaMode: GLTFAlphaMode;
    alphaCutoff: number;
    readonly flags: number;
}
